player = {}

player.x = 350
player.y = 350
player.speed = 7
player.xvel = 0
player.yvel = 0
player.friction = 2
player.maxspeed = 20

colorchoice = 1
function player:update(dt)
	local mousex,mousey = cam:mousepos() --Allows the mouse to be read inside the camera rather than the full screen
	self.rotation = math.atan2(mousey - self.y, mousex - self.x)
	particlerotation = math.atan2(player.y - mousey, player.x - mousex) --the opposite of player.rotation
	--This speed system allows for the gradual speeding up and slowing down of the player.
	self.x = self.x + self.xvel
	self.y = self.y + self.yvel
	
	self.xvel = self.xvel * (1 - math.min(dt*self.friction, .5))
	self.yvel = self.yvel * (1 - math.min(dt*self.friction, .5))
	
	if love.keyboard.isDown("a") and self.xvel < self.maxspeed then
		self.xvel = self.xvel - self.speed*dt
	end
	if love.keyboard.isDown("d") and self.xvel < self.maxspeed then
		self.xvel = self.xvel + self.speed*dt
	end
	if love.keyboard.isDown("w") and self.yvel < self.maxspeed then
		self.yvel = self.yvel - self.speed*dt
	end
	if love.keyboard.isDown("s") and self.yvel < self.maxspeed then
		self.yvel = self.yvel + self.speed*dt
	end
	
	--Updating the particle systems
	--I'll probably end up making a function for just this later.
	shipPS:start()
	shipPS:update(dt)

	shipPS:setDirection(particlerotation)
	shipPS:setPosition(self.x,self.y)	
	
	exps:setPosition(self.x,self.y)
	
	--Keeps the player contained.
	--Would it be easier to use objects for the borders? I don't know much about OOP...
	if self.x < 10 then
		self.x = 10
	end
	if self.x > 4780 then
		self.x = 4780
	end
	if self.y< 10 then
		self.y = 10
	end
	if self.y > 2380 then
		self.y = 2380
	end
end

function player:draw()
	love.graphics.draw(sprite[colorchoice], self.x, self.y, self.rotation,1,1,sprite[colorchoice]:getWidth()/2, sprite[colorchoice]:getHeight()/2)
end

bullet = {}
bullet.timer = 0
bullet.rate = 1
bullet.dt =.0259
bullet.speed = 1100

function bullet:shoot(dt)
bulletcolor = colorchoice --Links the bullet color to the ship color
	if love.mouse.isDown("r") then
		self.timer = self.timer +self.rate*self.dt
		if self.timer > self.rate then
			self:spawn(player.x, player.y) --This needs to be in a more precise spot. Idk how though
			self.timer = 0
			love.audio.play(self.lasersound) --Can't play the same sound overlapping(like in real Geowars...)
		end
	end
		for bi, bv in ipairs(bullet) do --Shoots the bullet from the front of the player
			bv.x = bv.x+(math.cos(bv.rot)*dt*self.speed)
		    bv.y = bv.y+(math.sin(bv.rot)*dt*self.speed)
			if bv.x < 0 or bv.x > 4800 or bv.y < 0 or bv.y > 2400 then --If bullet hits boundaries, it's gone
				table.remove(self, bi)
				bulletps:setPosition(bv.x,bv.y) --Just allows the bullets to look like they're blowing up when they hit shit
				bulletps:start()
			end
		end
end

function bullet:spawn(x, y)
	table.insert(bullet, {x=x, y=y,img=bulletimg[bulletcolor], rot=player.rotation})
end

function bullet_draw()
	for i,v in ipairs(bullet) do
		love.graphics.draw(v.img,v.x, v.y,v.rot)
	end
end


function set_colors(dt) --changes the colors of the particle systems
	if colorchoice == 1 then
		shipPS:setColors(100,100,0,120,150,50,10,160,255,0,0,255)
		exps:setColors(100,100,0,120,150,50,10,160,255,0,0,255)
		bulletps:setColors(100,100,0,120,150,50,10,160,255,0,0,255)
	end
	if colorchoice == 2 then
		shipPS:setColors(70,5,100,100,10,50,150,160,0,0,255,100)
		exps:setColors(70,5,100,100,10,50,150,160,0,0,255,100)
		bulletps:setColors(70,5,100,100,10,50,150,160,0,0,255,100)
	end
	if colorchoice == 3 then
		shipPS:setColors(70,100,0,150,10,150,50,160,0,255,0,0)
		exps:setColors(70,100,0,150,10,150,50,160,0,255,0,0)
		bulletps:setColors(70,100,0,150,10,150,50,160,0,255,0,0)
	end
	exps:update(dt)
	bulletps:update(dt)
end